//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;
using System.Reflection;
using System.Runtime.Remoting;
using InterAppDomain;

namespace AppDomainTest
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class InterAppDomain
	{
		static void Main(string[] args)
		{
			// Set ApplicationBase to the current directory

			AppDomainSetup info = new AppDomainSetup();

			info.ApplicationBase = "file:\\\\" + System.Environment.CurrentDirectory;

			// Create an application domain with null evidence

			AppDomain dom = AppDomain.CreateDomain("RemoteDomain", null, info);

			// Load the assembly HelloWorld2 and instantiate the type
			// HelloWorld
			BindingFlags flags = (BindingFlags.Public | BindingFlags.Instance | BindingFlags.CreateInstance);
			ObjectHandle objh = dom.CreateInstance("Fault", "InterAppDomain.Fault", false, flags, null, null, null, null, null);
			if (objh == null) 
			{
				Console.WriteLine("CreateInstance failed");
				return;
			}

			// Unwrap the object
			Object obj = objh.Unwrap();

			// Cast to the actual type
			Fault f = (Fault)obj;

			Console.WriteLine("In the application domain: {0} thread {1}", Thread.GetDomain().FriendlyName, Thread.CurrentThread.GetHashCode());

			try
			{
				// Invoke the method
				// f.DivideZero();
				f.Exception();
			}
			catch(Exception e)
			{
				Console.WriteLine(e.ToString());
			}

			// Clean up by unloading the application domain
			AppDomain.Unload(dom);  

		}
	}
}
