//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
///////////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) Microsoft Corp 2001.  All rights reserved.
//
//  Run: To throw an exception from managed-code to unmanaged-code: managed2unmanaged.cmd
//       To throw an exception from unmanaged-code to managed-code: unmanaged2managed.cmd
//
//  Description: Shows how to throw and handle NDP Exceptions in C++
//
///////////////////////////////////////////////////////////////////////////////

#include <iostream>

using namespace std;

class CException {
public:
    CException()
        : m_excode(0xFFFFFFFF) {
    }

    CException(unsigned int code)
        : m_excode(code) {
    }

    friend std::ostream &operator<<(std::ostream &out, const CException &e) {
        return out << "CException[" << e.m_excode << "]";
    }

    ~CException() {
    }

private:
    unsigned int m_excode;
};
